const { Logger } = require("../utils/Logger");
const { unzipFolder } = require("./directoryUtils");
const { getAPIProperties, getLintConfigDirectory } = require("./getFileUtils");
const { RequestAPI } = require("./RequestAPI");
const fs = require('fs')

function getLintConfigurationFilesAPI() {
  const { repositoryEndpoint, accessToken } = getAPIProperties();
  const options = {
    method: "GET",
    headers: { "PRIVATE-TOKEN" : `${accessToken}`}
}
  const api_action = (response) => {
    let fileChunk = "";
    if (response.statusCode === 200) {
      const fileStream = fs.createWriteStream(getLintConfigDirectory());
      response.pipe(fileStream);
      fileStream.on("finish", () => {
        fileStream.close();
      });
    } else {
      Logger.log(Logger.FAILURE_TYPE,`api failed - status ${500} `);
      process.exit(1)
    }

    response.on("data", (chunk) => { 
        fileChunk += chunk
        return;
    });


    response.on("end", () => { 
      if (response.statusCode === 200) {
        unzipFolder()
      }
    });
  }
  return RequestAPI(repositoryEndpoint, options,api_action);
}


getLintConfigurationFilesAPI()

module.exports = {
  getLintConfigurationFilesAPI
};
